;
;                  ͻ
;                                                             
;                   Fast-Rot V1.9b - (C) Zappy/Scoopex 1995 
;                                                             
;                   E-Mail: TERDIMAN_P@ESME.FR                
;                                                             
;                  ͼ
;
;
;This version is the 9th one since we coded the first in 1994 on Atari ST. ("we"
;means Elric and I, when we were members of Holocaust). The exact number of dots
;rotated in one frame depends on the computer and the object used. It should be
;something like 30000 dots/VBL on a DX2 66 and more than 60000 on a Pentium.
;Anyway, this is fast. By the way, this is not the fastest version you can get,
;but this is the easiest to use and understand.
;
;It seems it is possible to do projection & rotations at the same time since it
;just means you must pick different vectors for x and y according to the z....
;
;Press the "2" key to see the CPU time used, "1" to get rid of it.
;
;Green: time for the interpolation part.
;White: time for the rotations. In this example for 2959 vertex.
;
;                                                               Keep on coding!
;

CPUTEST	=	0
CPUTEST2	=	1 - CPUTEST

Amplitude	=	2*94
;Forced amplitude for the interpolations, Ram, and so on. It is quite enough
;precision for a 320 pixels wide screen. The more you increase amplitude, the
;more you increase precision, the more you need CPU time. (because of the Cache
;Memory) Try changing this value, and see the effect on the object and the CPU
;time.

	INCLUDE	f:\sources\var_hard.asm
	INCLUDE	f:\sources\std_equ.asm

b equ Byte Ptr
w equ Word Ptr
d equ Dword Ptr

	coul	macro	no_coul,rouge,vert,bleu
	push	dx
	push	ax
	mov	dx,3c8h
	mov	ax,no_coul
	out	dx,al
	inc	dx
	mov	al,rouge
	out	dx,al
	mov	al,vert
	out	dx,al
	mov	al,bleu
	out	dx,al
	pop	ax
	pop	dx
	endm

	INCLUDE	f:\sources\start32.asm
Start:
	mov	ecx,offset EndBss	;Clear BSS Section (useless...but I
	sub	ecx,offset StartBss	;used to do this on Atari...)
	shr	ecx,2
	xor	eax,eax
	mov	edi,offset StartBss
	rep	stosd

	mov	ax,13h			;Set Video mode
	int	10h

	mov	al,0ffh			;Interruptions out
	out	021h,al

	call	SetColors		;Guess...?

;Scan object to find maximum amplitude
	xor	edx,edx
	xor	ebx,ebx
	mov	esi,offset pts
	mov	ecx,n*3
@@ScanObj:	mov	eax,ds:[esi]
	cmp	eax,edx
	jle	@@L1
	mov	edx,eax
@@L1:	cmp	eax,ebx
	jge	@@L2
	mov	ebx,eax
@@L2:	add	esi,4
	dec	ecx
	jnz	@@ScanObj
	neg	ebx
	cmp	edx,ebx
	jge	@@fin_scan
	mov	edx,ebx
@@fin_scan:
;Here, edx = max amplitude


;Vertex resizing. A big precision is useless on a 320*200 screen, unless you
;want to slow down your code for nothing...
	mov	edi,edx
	mov	esi,offset pts
	mov	ecx,n*3
	mov	ebx,Amplitude		;Forced max amplitude
@@resizpt:	mov	eax,ds:[esi]		;coordinate
	imul	ebx			;coord*Amplitude
	idiv	edi
	mov	ds:[esi],eax
	add	esi,4
	dec	ecx
	jnz	@@resizpt

;Possible vertex alteration. For example you can force coordinates to be even.
;Hence, you don't need odd vectors anymore!..then buffers size is divided by 2,
;the code is faster. (Cache Memory again)
;The difference for the object is nearly invisible if the object is big enough.
;Not really clean, I know...
	mov	esi,offset pts		;; Remove those lines for
	mov	ecx,n*3                 ;; something cleaner.
@@trspts:	mov	eax,ds:[esi]            ;;
	and	eax,-2		;even   ;;
	mov	ds:[esi],eax            ;;
	add	esi,4                   ;;
	dec	ecx                     ;;
	jnz	@@trspts                ;;

;Look for used vectors in the object. Then kill all the others after the
;interpolation in order to minimize the size of the datas_buffers. (once more,
;this has to do with Cache Memory.)
	mov	esi,offset pts
	mov	edi,offset Buf_Trv
	mov	ecx,n*3
@@init_Buf_Trv:
	mov	ebx,ds:[esi]
	or	ebx,ebx
	jge	@@dt_ps
	neg	ebx
@@dt_ps:	mov	ds:[edi+ebx],b 1	;1=used, 0=non used
	add	esi,4
	dec	ecx
	jnz	@@init_Buf_Trv


;Vertex sort.. There are 8 corners in a box, and we must have:
;      vertex for the 1st corner ( X>0, Y>0, Z>0 )
; then vertex for the 2nd corner ( X<0, Y>0, Z>0 )
; then vertex for the 3rd corner ( X>0, Y<0, Z>0 )
; then vertex for the 4th corner ( X<0, Y<0, Z>0 )
; then vertex for the 5th corner ( X>0, Y>0, Z<0 )
; then vertex for the 6th corner ( X<0, Y>0, Z<0 )
; then vertex for the 7th corner ( X>0, Y<0, Z<0 )
; then vertex for the 8th corner ( X<0, Y<0, Z<0 )
; ....in order to kill all negative vectors in the vector buffers. (you know
; where you must ADD or SUB the vector)
;Hence, buffers are smaller, code is faster, Cache Memory is happy -Zappy's
;happy too *8)
;
;There is a way to avoid sorting the vertex like this before rotating them, but
;the resulting code is slower...
;
	mov	edi,offset RealBuffer
	mov	ebp,offset RealCounter
	xor	edx,edx
@@next_critere:
	mov	esi,offset pts
	xor	ecx,ecx			;number of vertex in this corner
@@next_plot:
	xor	ebx,ebx
	cmp	ds:[esi],d 0
	jge	@@plus_1
	add	ebx,1
@@plus_1:	cmp	ds:[esi+4],d 0
	jge	@@plus_2
	add	ebx,2
@@plus_2:	cmp	ds:[esi+8],d 0
	jge	@@plus_3
	add	ebx,4
@@plus_3:	cmp	ebx,edx			;same criterion?
	jnz	@@ss1234bzg
	inc	ecx			;one more vertex in this section
	mov	eax,ds:[esi]
	mov	ds:[edi],eax
	mov	eax,ds:[esi+4]
	mov	ds:[edi+4],eax
	mov	eax,ds:[esi+8]
	mov	ds:[edi+8],eax		;copy vertex
	add	edi,12
@@ss1234bzg:add	esi,12
	cmp	esi,offset pts+n*12
	jnz	@@next_plot
	mov	ds:[ebp],ecx		;stock number of vertex
	add	ebp,4
	inc	edx
	cmp	edx,8
	jl	@@next_critere
	;copy RealBuffer in pts
	mov	esi,offset RealBuffer
	mov	edi,offset pts
	mov	ecx,n*3
@@next_ghju:mov	eax,ds:[esi]
	or	eax,eax
	jge	@@okkyu
	neg	eax
@@okkyu:	mov	ds:[edi],eax
	add	esi,4
	add	edi,4
	dec	ecx
	jnz	@@next_ghju		;vertex are now sorted in 'pts'

;Creation of the (temporary) correspondence table
	mov	esi,offset Buf_Trv
	mov	edi,offset TbCores
	xor	eax,eax
	mov	ecx,Amplitude
@@do_tbl:	cmp	ds:[esi],b 0
	jnz	@@used
	mov	ds:[edi],d 0ffffffffh
	jmp	@@nxt_one
@@used:	mov	d ds:[edi],eax
	inc	eax
@@nxt_one:	inc	esi
	add	edi,4
	dec	ecx
	jnz	@@do_tbl
	mov	Virt_Amp,eax
	;here, eax = virtual amplitude

;Modify vertex according to used vectors.
	mov	esi,offset pts
	mov	edi,offset TbCores
	mov	ecx,n*3
@@mdpts:	mov	ebx,ds:[esi]
	cmp	ebx,0
	jge	@@pstv
	neg	ebx
@@pstv:	shl	ebx,2
	mov	ebx,ds:[edi+ebx]        ;ebx = vertex number
	cmp	ebx,d 0ffffffffh
	jnz	@@ca_roule
	coul	0 60 0 0		;If your screen becomes red, you
@@sys_halt:	jmp	@@sys_halt		;have some problems!
@@ca_roule:	add	ebx,ebx
	lea	ebx,ds:[ebx*2+ebx]      ;*6 'coz x,y,z to jump
	mov	ds:[esi],ebx
	add	esi,4
	dec	ecx
	jnz	@@mdpts

;Offsets creation for the creation of the real array
	mov	esi,offset Buf_Trv
	mov	edi,offset TbCores
	xor	eax,eax
	mov	ecx,Amplitude
@@cre_inc:	cmp	ds:[esi],b 0
	jz	@@unused
	mov	ds:[edi],eax
	add	edi,4
@@unused:	add	eax,4           ;4 'coz stosd
	inc	esi
	dec	ecx
	jnz	@@cre_inc

;Vertex optimization.
	mov	esi,offset pts
	mov	ebx,Virt_Amp
	add	ebx,ebx
	lea	ebx,ds:[ebx*2+ebx]
	mov	ecx,n
@@optpts:	mov	eax,ds:[esi]
	add	eax,offset Bufx
	mov	ds:[esi],eax            ;x+offset Bufx

	mov	eax,ds:[esi+4]
	add	eax,offset Bufx
	add	eax,ebx
	mov	ds:[esi+4],eax          ;y+offset Bufx+Virt_Amp*6

	mov	eax,ds:[esi+8]
	add	eax,offset Bufx
	add	eax,ebx
	add	eax,ebx
	mov	ds:[esi+8],eax          ;z+offset Bufx+Virt_Amp*12

	add	esi,12
	dec	ecx
	jnz	@@optpts
;

	mov	Phi,d 0			;Init rotation angles
	mov	Psi,d 0
	mov	Theta,d 0

	cli



Vbl_routy:
	coul	0 0 0 0
	IF	CPUTEST2
	call	aff_eff
	ENDIF

	cmp	Flag_Cpu,0
	jz	@@NoVisu
	coul	0 0 60 0
@@NoVisu:

;Rotate the 3 dots of the trihedron.
	mov	esi,offset pts_triedre
	mov	edi,offset Coor_Rot_t
	mov	ecx,3			;trihedron, 3 vertex
	call	Mk_Rotations		;This is a classic rotation-routy,
					;only to rotate the trihedron...

;Create virtual vertex.
	mov	esi,offset Coor_Rot_t
	mov	ecx,3
	xor	ebp,ebp
@@rot_trd:	push    ecx

	mov	edi,offset Pts_x
	xor	eax,eax
	add	edi,ebp
	xor	ebx,ebx
	mov	ax,w ds:[esi]		;x max
	call	interpol

	mov	edi,offset Pts_y
	xor	eax,eax
	add	edi,ebp
	xor	ebx,ebx
	mov	ax,w ds:[esi+2]		;y max
	call	interpol

	mov	edi,offset Pts_z
	xor	eax,eax
	add	edi,ebp
	xor	ebx,ebx
	mov	ax,w ds:[esi+4]		;z max
	call	interpol

	pop	ecx
	add	esi,6			;next pt==next vector
	add	ebp,Amplitude*4		;next vector, 4 coz stosd

	dec	ecx
	jnz	@@rot_trd

;Create real array

	mov	edi,offset Bufx
	mov	eax,3
	xor	edx,edx
@@cp2:	push	eax

	mov	ebp,offset TbCores
	mov	esi,offset Pts_x+2
	mov	ecx,Virt_Amp
	add	esi,edx

	push	edx
@@cp1:
	mov	edx,ds:[ebp]		;number of the vertex to pick
	mov	ax,w ds:[esi+edx]			;interpolated x
	mov	bx,w ds:[esi+edx+Amplitude*4*3]		;interpolated y
	mov	dx,w ds:[esi+edx+Amplitude*4*3*2]	;interpolated z
	mov	w ds:[edi],ax
	mov	w ds:[edi+2],bx
	mov	w ds:[edi+4],dx
	add	ebp,4
	add	edi,6
	dec	ecx
	jnz	@@cp1

	pop	edx
	pop	eax
	add	edx,Amplitude*4			;Next vector
	dec	eax
	jnz	@@cp2

	cmp	Flag_Cpu,0
	jz	@@fds
	coul	0 42 42 42
@@fds:

;Rotate real vertex.

	mov	esi,offset Bufx		;; Useless on Pentium.
	mov	ecx,20			;; Usefull on my DX2/66.
@@initcache:mov	eax,ds:[esi]		;;
	add	esi,10			;;
	dec	ecx			;;
	jnz	@@initcache		;;

	mov	edx,1	;37	just to see how much loop I can do

	IF	CPUTEST
	;mov	edx,37
	mov	edx,22
	ENDIF

@@lab:	push	edx

	mov	esi,offset pts
	mov	edi,offset RealCounter

	;+++
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_1	;may be usefull. Depends on the object!
	push	edi
@@fast_rot_part_one:
	mov	ebx,ds:[esi]		;x from vertex
	mov	eax,ds:[esi+2*2]	;y from vertex
	mov	edi,ds:[esi+4*2]	;z from vertex
	;Here you should put a third instruction to be sure not to have
	;an AGI on ebx.
	mov	ebp,ds:[ebx]		;x/y from vector
	mov	dx,ds:[ebx+4]		;z from vector

	add	ebp,ds:[eax]		;x/y from vector
	add	dx,ds:[eax+4]		;z from vector

	add	ebp,ds:[edi]		;x/y from vector
	add	dx,ds:[edi+4]		;z from vector

	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	;To speed up your code you should do the projection here, instead
	;of saving your coordinates in a buffer.

	;x and y are on the same dword, just to go faster. Of course it
	;means they must be coded on 15 bits, and not 16. Let's just suppose
	;this is enough for a demo!

	add	esi,6*2

	dec	ecx
	jnz	@@fast_rot_part_one
	pop	edi
@@passe_1:
	;-++
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_2
	push	edi
@@fast_rot_part_two:
	mov	ebx,ds:[esi+2*2]
	mov	eax,ds:[esi]
	mov	edi,ds:[esi+4*2]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	add	ebp,ds:[edi]
	add	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_two
	pop	edi
@@passe_2:
	;+-+
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_3
	push	edi
@@fast_rot_part_three:
	mov	ebx,ds:[esi]
	mov	eax,ds:[esi+2*2]
	mov	edi,ds:[esi+4*2]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	add	ebp,ds:[edi]
	add	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_three
	pop	edi
@@passe_3:
	;--+
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_4
	push	edi
@@fast_rot_part_four:
	mov	ebx,ds:[esi+4*2]
	mov	eax,ds:[esi+2*2]
	mov	edi,ds:[esi]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	sub	ebp,ds:[edi]
	sub	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_four
	pop	edi
@@passe_4:
	;++-
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_5
	push	edi
@@fast_rot_part_five:
	mov	ebx,ds:[esi]
	mov	eax,ds:[esi+2*2]
	mov	edi,ds:[esi+4*2]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	add	ebp,ds:[eax]
	add	dx,ds:[eax+4]
	sub	ebp,ds:[edi]
	sub	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_five
	pop	edi
@@passe_5:
	;-+-
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_6
	push	edi
@@fast_rot_part_six:
	mov	ebx,ds:[esi+2*2]
	mov	eax,ds:[esi+4*2]
	mov	edi,ds:[esi]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	sub	ebp,ds:[edi]
	sub	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_six
	pop	edi
@@passe_6:
	;+--
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_7
	push	edi
@@fast_rot_part_seven:
	mov	ebx,ds:[esi]
	mov	eax,ds:[esi+2*2]
	mov	edi,ds:[esi+4*2]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	sub	ebp,ds:[edi]
	sub	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_seven
	pop	edi
@@passe_7:
	;---
	mov	ecx,ds:[edi]
	add	edi,4
	;jecxz	@@passe_8
	push	edi
@@fast_rot_part_eight:
	mov	ebx,ds:[esi]
	mov	eax,ds:[esi+2*2]
	mov	edi,ds:[esi+4*2]
	mov	ebp,ds:[ebx]
	mov	dx,ds:[ebx+4]
	neg	ebp
	neg	dx
	sub	ebp,ds:[eax]
	sub	dx,ds:[eax+4]
	sub	ebp,ds:[edi]
	sub	dx,ds:[edi+4]
	mov	ds:[esi+offset Coor_Rot-offset pts],ebp
	mov	ds:[esi+offset Coor_Rot-offset pts+4],dx
	add	esi,6*2
	dec	ecx
	jnz	@@fast_rot_part_eight
	pop	edi
@@passe_8:
@@fin_rot:
	pop	edx
	dec	edx
	jnz	@@lab

	add	Phi, d 2	;x angle
	and	Phi, d 2047
	add	Psi, d 4	;y angle
	and	Psi, d 2047
	add	Theta, d 10	;z angle
	and	Theta, d 2047

	cmp	Flag_Cpu,0
	jz	@@affich_object
	coul	0,0,0,0
@@affich_object:

	IF	CPUTEST
	jmp	ILoveBjork
	ENDIF

;All the following code is REALLY not optimized. This is just a test to see
;the object rotate.

;phase calcul de projection...
	xor	ebx,ebx
	xor	edx,edx
	mov	ebp,offset Coor_Rot
	mov	edi,n
@@next_dot:	movsx	ebx,w ds:[ebp+4]
	add	ebx,ebx
	add	ebx,offset coeff_3d+(256+160)*2
	mov	bx,w ds:[ebx]
	mov	dx,w ds:[ebp]
	mov	ax,bx
	sal	dx,2
	imul	dx
	add	dx,160
	or	dx,dx
	jl	@@clipq
	cmp	dx,319
	jg	@@clipq
	push	dx
	mov	dx,w ds:[ebp+2]
	mov	ax,bx
	sal	dx,2
	imul	dx
	xor	ebx,ebx
	pop	bx
	add	dx, 100
	or	dx,dx
	jl	@@clipq
	cmp	dx,199
	jg	@@clipq
	lea	edx,ds:[edx*4+edx]
	shl	edx,6
	push	dx
	xor	edx,edx
	pop	dx
	mov	b ds:[edx+ebx+offset VideoBuffer],240
@@clipq:	add	ebp,6*2
	dec	edi
	jnz	@@next_dot

ILoveBjork:	cmp	Flag_Cpu,0
	jz	no_cpu
	call	vsync
no_cpu:
	in	al,60h
	cmp	al,2
	jnz	cc
	mov	Flag_Cpu,0
cc:
	cmp	al,3
	jnz	cc2
	mov	Flag_Cpu,1
cc2:	dec	al
	jnz	Vbl_routy

fin:	xor	al,al
	out	021h,al
	sti
	retf

vsync:	mov	dx,3dah
@@wait_1:	in	al,dx
	test	al,8
	jnz	@@wait_1
@@wait_2:	in	al,dx
	test	al,8
	jz	@@wait_2
	ret

interpol:	sub	ax,bx
	mov	ecx,d Amplitude-1
	shl	eax,16
	cdq
	idiv	ecx
	shl	ebx,16
	inc	ecx
@@Inter:	mov	ds:[edi],ebx
	add	ebx,eax
	add	edi,4
	dec	ecx
	jnz	@@Inter
	ret

aff_eff:	mov	edi,offset VideoBuffer
	mov	ebx,000a0000h
	mov	ecx,64000/4
	xor	eax,eax
@@afef:	mov	edx,ds:[edi]
	mov	ds:[ebx],edx
	stosd
	add	ebx,4
	dec	ecx
	jnz	@@afef
	ret

SetColors:	mov	edx,d 3c8h
	xor	eax,eax
	out	dx,al
	inc	edx
	mov	esi,offset colors_degrad
	mov	ecx,d 256
@@lp_pal:	mov	al,ds:[esi+0]
	out	dx,al
	mov	al,ds:[esi+1]
	out	dx,al
	mov	al,ds:[esi+2]
	out	dx,al
	add	esi,3
	dec	ecx
	jnz	@@lp_pal
	ret

	include	f:\sources\zap32\fastrot\rt_rot_2.s

;
;				SECTION DATA
;

	include	f:\sources\zap32\fastrot\tbsin.dat
	include	f:\sources\zap32\fastrot\sepia.pal

pts_triedre:dw	Amplitude*4, 0, 0
	dw	0, Amplitude*4, 0
	dw	0, 0, Amplitude*4

	align	4	;leave it or die!
;	include	d:\sources\zap32\fastrot\dauph2b.pts	;343 vertex
;	include	f:\sources\zap32\fastrot\torso3b.pts	;1852 vertex
;	include	f:\sources\zap32\fastrot\ducky.pts	;270 vertex
	include	f:\sources\zap32\fastrot\tricera.pts	;2959 vertex

	align	4
	include	f:\sources\zap32\fastrot\coeff5.s	;3D coeffs for projection

;
;				SECTION BSS
;


StartBss:
			align	4
RealBuffer			dd	n*3		dup	(?)
RealCounter			dd	8		dup	(?)

Virt_Amp			dd	?
Buf_Trv			db	Amplitude	dup	(?)
			align	4
TbCores			dd	Amplitude	dup	(?)

Bufx			dw	Amplitude*3	dup	(?)
Bufy			dw	Amplitude*3	dup	(?)
Bufz			dw	Amplitude*3	dup	(?)

Pts_x			dw	Amplitude*2*3	dup	(?)
Pts_y			dw	Amplitude*2*3	dup	(?)
Pts_z			dw	Amplitude*2*3	dup	(?)

Coor_Rot_t			dw	3*3		dup	(?)
			dw	?
Coor_Rot			dw	n*3*2		dup	(?)

Flag_Cpu			dd	?

Theta			dd	?
Phi			dd	?
Psi			dd	?
matrice			dw	9		dup	(?)
			dw	?
VideoBuffer:		db	65536		dup	(?)

			dd	?
EndBss:

ENDS
END Start
